"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class FamilyLevelQuestions(ProtocolElement):
    """
    The family level questions
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "additionalComments",
        "caseSolvedFamily",
        "segregationQuestion",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_0 import reports as reports_6_0_0

        return {
            "caseSolvedFamily": reports_6_0_0.CaseSolvedFamily,
            "segregationQuestion": reports_6_0_0.SegregationQuestion,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_0 import reports as reports_6_0_0

        return {
            "org.gel.models.report.avro.CaseSolvedFamily": reports_6_0_0.CaseSolvedFamily,
            "org.gel.models.report.avro.SegregationQuestion": reports_6_0_0.SegregationQuestion,
            "org.gel.models.report.avro.FamilyLevelQuestions": reports_6_0_0.FamilyLevelQuestions,
        }

    __slots__ = [
        "additionalComments",
        "caseSolvedFamily",
        "segregationQuestion",
    ]

    def __init__(
        self,
        additionalComments,
        caseSolvedFamily,
        segregationQuestion,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_0_0.FamilyLevelQuestions model.

        :param additionalComments:
            Comments regarding report
        :type additionalComments: str
        :param caseSolvedFamily:
            Have the results reported here explained the genetic basis of the
            family s presenting phenotype(s)?
        :type caseSolvedFamily: CaseSolvedFamily
        :param segregationQuestion:
            Have you done any segregation testing in non-participating family
            members?
        :type segregationQuestion: SegregationQuestion
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.0.0"
